org.springframework.jmx.access

## Class NotificationListenerRegistrar

- java.lang.Object
- - org.springframework.jmx.support.NotificationListenerHolder
  - - org.springframework.jmx.access.NotificationListenerRegistrar

- All Implemented Interfaces:
    DisposableBean, InitializingBean

      public class NotificationListenerRegistrar
      extends NotificationListenerHolder
      implements InitializingBean, DisposableBean

  Registrar object that associates a specific `NotificationListener` with one or more MBeans in an `MBeanServer` (typically via a `MBeanServerConnection`).
  Since:
    2.5.2
  Author:
    Juergen Hoeller
  See Also:
    `setServer(javax.management.MBeanServerConnection)`, `NotificationListenerHolder.setMappedObjectNames(java.lang.Object...)`, `NotificationListenerHolder.setNotificationListener(javax.management.NotificationListener)`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Log` | `logger` Logger available to subclasses.

    - ### Fields inherited from class org.springframework.jmx.support.NotificationListenerHolder

      `mappedObjectNames`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `NotificationListenerRegistrar()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterPropertiesSet()` Invoked by the containing `BeanFactory` after it has set all bean properties and satisfied `BeanFactoryAware`, `ApplicationContextAware` etc.
    `void` | `destroy()` Unregisters the specified `NotificationListener`.
    `Map<String,?>` | `getEnvironment()` Allow `Map` access to the environment to be set for the connector, with the option to add or override specific entries.
    `void` | `prepare()` Registers the specified `NotificationListener`.
    `void` | `setAgentId(String agentId)` Set the agent id of the `MBeanServer` to locate.
    `void` | `setEnvironment(Map<String,?> environment)` Specify the environment for the JMX connector.
    `void` | `setServer(MBeanServerConnection server)` Set the `MBeanServerConnection` used to connect to the MBean which all invocations are routed to.
    `void` | `setServiceUrl(String url)` Set the service URL of the remote `MBeanServer`.

    - ### Methods inherited from class org.springframework.jmx.support.NotificationListenerHolder

      `equals, getHandback, getNotificationFilter, getNotificationListener, getResolvedObjectNames, hashCode, setHandback, setMappedObjectName, setMappedObjectNames, setNotificationFilter, setNotificationListener`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### logger

          protected final Log logger

      Logger available to subclasses.

  - ### Constructor Detail

    - #### NotificationListenerRegistrar

          public NotificationListenerRegistrar()

  - ### Method Detail

    - #### setServer

          public void setServer(MBeanServerConnection server)

      Set the `MBeanServerConnection` used to connect to the MBean which all invocations are routed to.

    - #### setEnvironment

          public void setEnvironment(@Nullable
                                     Map<String,?> environment)

      Specify the environment for the JMX connector.
      See Also:
        `JMXConnectorFactory.connect(javax.management.remote.JMXServiceURL, java.util.Map)`

    - #### getEnvironment

          @Nullable
          public Map<String,?> getEnvironment()

      Allow `Map` access to the environment to be set for the connector, with the option to add or override specific entries.

      Useful for specifying entries directly, for example via `environment[myKey]`. This is particularly useful for adding or overriding entries in child bean definitions.

    - #### setServiceUrl

          public void setServiceUrl(String url)
                             throws MalformedURLException

      Set the service URL of the remote `MBeanServer`.
      Throws:
        `MalformedURLException`

    - #### setAgentId

          public void setAgentId(String agentId)

      Set the agent id of the `MBeanServer` to locate.

      Default is none. If specified, this will result in an attempt being made to locate the attendant MBeanServer, unless the `"serviceUrl"` property has been set.

      See Also:
        `

        Specifying the empty String indicates the platform MBeanServer.

        `

    - #### afterPropertiesSet

          public void afterPropertiesSet()

      Description copied from interface: `InitializingBean`
      Invoked by the containing `BeanFactory` after it has set all bean properties and satisfied `BeanFactoryAware`, `ApplicationContextAware` etc.

      This method allows the bean instance to perform validation of its overall configuration and final initialization when all bean properties have been set.

      Specified by:
        `afterPropertiesSet` in interface `InitializingBean`

    - #### prepare

          public void prepare()

      Registers the specified `NotificationListener`.

      Ensures that an `MBeanServerConnection` is configured and attempts to detect a local connection if one is not supplied.

    - #### destroy

          public void destroy()

      Unregisters the specified `NotificationListener`.
      Specified by:
        `destroy` in interface `DisposableBean`